<script setup>
import {ref} from 'vue';
import {genericError, inscriptionForm} from "@/common/ServerAPI.js";

const email = ref(null);
const emailValid = ref(false);
const firstname = ref(null);
const firstnameValid = ref(false);
const lastname = ref(null);
const lastnameValid = ref(false);
const comment = ref(null);
const accountToken = ref(null);

const telegram = ref(null);
const discord = ref(null);

const validCharte = ref(false);
const validPresent = ref(false);
const sectionYear = ref(null);
const section = ref(null);


const valid = ref(false);

function recomputeValid() {
  valid.value = emailValid.value && firstnameValid.value && lastnameValid.value && validCharte.value && validPresent.value && sectionYear.value != null && section.value != null && accountToken.value != null;
}

function emailChange() {
  emailValid.value = email.value !== null && email.value !== "";
  recomputeValid();
}

function firstnameChange() {
  firstnameValid.value = firstname.value !== null && firstname.value !== "";
  recomputeValid();
}

function lastnameChange() {
  lastnameValid.value = lastname.value !== null && lastname.value !== undefined && lastname.value !== "";
  recomputeValid();
}

function generateKey() {
  const randomValues = window.crypto.getRandomValues(new Uint32Array(2));
  accountToken.value = "s4skey_" + randomValues[0] + "" + randomValues[1];
  recomputeValid();
}

const messingUp = ref(false);
const validated = ref(false);

function validate() {
  messingUp.value = true;

  function val(reference) {
    if (reference.value == null || reference.value === "") {
      return null;
    } else {
      return reference.value;
    }
  }

  inscriptionForm(msg => {
    if (msg === "RECEIVED INSCRIPTION FORM") {
      validated.value = true;
    } else {
      genericError();
      window.location = "/inscription";
    }
  }, () => {
    genericError();
    window.location = "/inscription";
  }, JSON.stringify({
    email: val(email),
    firstname: val(firstname),
    lastname: val(lastname),
    telegram: val(telegram),
    discord: val(discord),
    notes: val(comment),
    key: val(accountToken),
    section: val(section),
    sectionYear: val(sectionYear),
  }));
}


</script>
<template>
  <section class="bg-gray-50 dark:bg-gray-900 md:mt-20" v-if="messingUp && !validated">
    <div class="flex flex-col items-center justify-center px-6 py-8 mx-auto lg:py-0">
      <div
          class="w-full bg-s4s-redwood-600 rounded-lg shadow dark:border md:mt-0 sm:max-w-4xl xl:p-0 dark:bg-gray-800 dark:border-gray-700">
        <div style="padding: 10px">
          <b style="font-size: 40px">Traitement en cours</b><br>
          <p>Cela ne devrait prendre que quelques secondes</p>
        </div>
      </div>
    </div>
  </section>

  <section class="bg-gray-50 dark:bg-gray-900 md:mt-20" v-if="validated">
    <div class="flex flex-col items-center justify-center px-6 py-8 mx-auto lg:py-0">
      <div
          class="w-full bg-s4s-redwood-600 rounded-lg shadow dark:border md:mt-0 sm:max-w-4xl xl:p-0 dark:bg-gray-800 dark:border-gray-700">
        <div style="padding: 10px">
          <b style="font-size: 40px">Formulaire d'inscription envoyé</b><br>
          <p>Le formulaire a bien été envoyé.</p><br>
          <p>Merci encore pour ton intérêt et pour avoir rempli ce formulaire :)<br>
            Nous te répondrons dans quelques jours par mail.</p><br>
          <p>Le mail qui a été fourni: <span style="color:blue; margin: 5px">{{ email }}</span></p>
          <p>N'oublie pas d'enregistrer la clé suivante :<span style="color:blue; margin: 5px">{{ accountToken }}</span><br>
          </p>
        </div>
      </div>
    </div>
  </section>


  <section class="bg-gray-50 dark:bg-gray-900 md:mt-20" v-if="!messingUp">
    <div class="flex flex-col items-center justify-center px-6 py-8 mx-auto lg:py-0">
      <div
          class="w-full bg-s4s-redwood-600 rounded-lg shadow dark:border md:mt-0 sm:max-w-4xl xl:p-0 dark:bg-gray-800 dark:border-gray-700">
        <div style="padding: 10px">
          <b style="font-size: 40px">Inscription à S4S</b><br>
          <div>
            Salut !<br>
            Merci pour ton intérêt pour la semaine Students 4 Students :)<br>
            Pour rappel, celle-ci se déroule du 29 août au 5 septembre (inclus) à l'EPFL.<br>
            <br>
            Note que nous réservons les places à S4S aux personnes entrant pour la première fois en BA1 ainsi qu'au CMS,<br>
            pour toutes les sections sauf Architecture. Les redoublants peuvent s'inscrire, mais auront une priorité<br>
            plus basse.<br>
            <br>
            Plus d'informations sur la semaine sur <a style="color: blue" href="https://students4students.ch">students4students.ch</a>
            !<br>
          </div>
        </div>
        <div style="padding: 10px">
          <b style="font-size: 30px">Formulaire</b><br>
          <div style="padding: 10px">
            <label>Email:</label><br>
            <input type="text" v-model="email" @keyup="emailChange"><br>
            <p style="color: red" v-if="!emailValid">⚠ Champ obligatoire</p><br>
            <label>Prénom:</label><br>
            <input type="text" v-model="firstname" @keyup="firstnameChange"><br>
            <p style="color: red" v-if="!firstnameValid">⚠ Champ obligatoire</p><br>
            <label>Nom:</label><br>
            <input type="text" v-model="lastname" @keyup="lastnameChange"><br>
            <p style="color: red" v-if="!lastnameValid">⚠ Champ obligatoire</p><br>
          </div>
        </div>

        <div style="padding: 10px">
          <b style="font-size: 30px">Compte S4S</b><br>
          <div style="padding: 10px">
            <p>Tu auras un compte S4S qui te permettra de voir l'état de ton inscription, de participer aux workshops,
              et bien plus encore</p>
            <p>Il y a plusieurs manières de s'y connecter: par Telegram, par Discord, par Mail, ou par une clé.</p>
            <button style="background-color: blue; color: white; padding: 10px" @click="generateKey">Générer une clé
            </button>
            <span style="color:blue; margin: 5px">{{ accountToken }}</span><br>
            <p style="color: red" v-if="accountToken == null">⚠ Champ obligatoire</p>
            <p>Il faut générer une clé et la <b>sauvegarder</b>.</p>
            <br>
            <p>On recommande aussi d'autres méthodes de connexion:</p>
            <label>ID Telegram (optionnel, mais recommandé):</label><br>
            <input type="text" v-model="telegram"><br>
            <p>Pour récupérer ton ID Telegram, contacte le bot <a style="color: blue"
                                                                  href="https://t.me/Students4StudentsBOt">@Students4StudentsBot</a>
            </p>
            <br>
            <label>Username Discord (optionnel, mais recommandé):</label><br>
            <input type="text" v-model="discord">
            <p>Ne pas confondre l'username discord du pseudo discord!<br>L'image ci-dessous indique comment trouver
              l'username :</p>
            <img src="@/assets/discordusernametutorial.png"/>
          </div>
        </div>
        <div style="padding: 10px">
          <b style="font-size: 30px">Quel semestre commences-tu en septembre ?</b><br>
          <p style="color: red" v-if="sectionYear == null">⚠ Champ obligatoire</p>
          <div style="margin: 10px">

            <input @change="recomputeValid" type="radio" v-model="sectionYear" value="BA1" style="margin: 5px"
                   id="section-year-BA1"><label
              for="section-year-BA1">BA1 - 1ère tentative </label><br>
            <input @change="recomputeValid" type="radio" v-model="sectionYear" value="BA1-bis" style="margin: 5px"
                   id="section-year-BA1-bis"><label
              for="section-year-BA1-bis">BA1 - Redoublement</label><br>
            <input @change="recomputeValid" type="radio" v-model="sectionYear" value="CMS" style="margin: 5px"
                   id="section-year-CMS"><label
              for="section-year-CMS">CMS</label><br>
          </div>
        </div>

        <div style="padding: 10px">
          <b style="font-size: 30px">Quelle section rejoins-tu en septembre ?</b><br>
          <p style="color: red" v-if="section == null">⚠ Champ obligatoire</p>
          <div style="margin: 10px">

            <p>Ce choix aura une influence sur les cours qui te seront proposés pendant la semaine S4S.</p><br>

            <input @change="recomputeValid" type="radio" v-model="section" value="CGC" style="margin: 5px"
                   id="section-CGC"><label
              for="section-CGC">CGC - Chimie et génie chimique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="MA" style="margin: 5px"
                   id="section-MA"><label
              for="section-MA">MA
            - Mathématiques</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="PH" style="margin: 5px"
                   id="section-PH"><label
              for="section-PH">PH
            - Physique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="IN" style="margin: 5px"
                   id="section-IN"><label
              for="section-IN">IN
            - Informatique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="SC" style="margin: 5px"
                   id="section-SC"><label
              for="section-SC">SC
            - Systèmes de communication</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="EL" style="margin: 5px"
                   id="section-EL"><label
              for="section-EL">EL
            - Génie électrique et électronique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="GM" style="margin: 5px"
                   id="section-GM"><label
              for="section-GM">GM
            - Génie mécanique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="MT" style="margin: 5px"
                   id="section-MT"><label
              for="section-MT">MT
            - Microtechnique</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="MX" style="margin: 5px"
                   id="section-MX"><label
              for="section-MX">MX
            - Science et génie des matériaux</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="SV" style="margin: 5px"
                   id="section-SV"><label
              for="section-SV">SV
            - Ingénierie des sciences du vivant</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="GC" style="margin: 5px"
                   id="section-GC"><label
              for="section-GC">GC
            - Génie civil</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="SIE" style="margin: 5px"
                   id="section-SIE"><label
              for="section-SIE">SIE - Sciences et ingénierie de l'environnement</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="CMS" style="margin: 5px"
                   id="section-CMS"><label
              for="section-CMS">CMS - Cours de mathématiques spéciales</label><br>
            <input @change="recomputeValid" type="radio" v-model="section" value="AR" style="margin: 5px"
                   id="section-AR"><label
              for="section-AR">AR
            - Architecture</label><br>
          </div>
        </div>

        <div style="padding: 10px">

          <b style="font-size: 30px">Remarques et questions (allergies ou autres)</b><br>
          <div style="margin: 10px">
            <p>Cette partie n'est pas décisive pour l'acceptation</p><br>
            <textarea v-model="comment" style="width: 500px"></textarea>
          </div>
        </div>

        <div style="padding: 10px;">
          <b style="font-size: 30px">Validation</b><br>
          <div>
            <input @change="recomputeValid" type="checkbox" v-model="validCharte" id="valid-charte"
                   style="margin: 10px"><label
              for="valid-charte">J'ai lu la charte de
            participation (droit à l'image etc) <a style="color: blue"
                                                   href="https://students4students.ch/Charte_Participation.pdf"
                                                   target="_blank" rel="noopener noreferrer">disponible
              ici</a></label><br>
            <p style="color: red" v-if="!validCharte">⚠ Champ obligatoire</p>
          </div>
          <div>
            <input type="checkbox" v-model="validPresent" id="valide-present" @change="recomputeValid"
                   style="margin: 10px">
            <label for="valide-present">J'atteste que, dans le cas où j'obtiendrais une place à S4S, je me présenterai
              aux
              cours
              et exercices proposés dans
              la limite de mes disponibilités.</label><br>
            <p style="color: red" v-if="!validPresent">⚠ Champ obligatoire</p>
          </div>
          <!--I'm pooping code-->
          <button v-if="valid" style="padding: 10px; background-color: blue; color: white" @click="validate">
            Valider
          </button>
          <button v-if="!valid" style="padding: 10px; background-color: gray; color: white">
            Valider
          </button>
          <p style="color: red" v-if="!valid">⚠ Tous les champs n'ont pas été rempli</p>
        </div>
      </div>
    </div>
    <!--     ATTENTION : Nous sommes actuellement complets pour cette année. Si tu remplis ce formulaire, tu seras placé·e dans une file d'attente. Nous t'enverrons un mail au cas où une place se libère pour toi. Cependant, au vu de la file d'attente actuelle, nous ne pensons pas pouvoir accueillir plus de participant·e·s...-->
  </section>
</template>
